<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');
require_once(APPPATH.'classes/ci_extend_libraries/PaymentControllerBase.abstract.php');	

/**
 * 
 */
class Sale extends PaymentControllerBase 
{
	/**
	 * コンストラクタ
	 */
	public function __construct()
	{
		parent::__construct();	
	}
	/**
	 * index
	 */
	public function index()
	{
		$this->_execTransaction();
	}
	/**
	 * 
	 */
	protected function _onSubmit(&$paydrv, &$obj_req)
	{
		$res = null;
		//
		switch(strtoupper($obj_req->PAYMENTTYPE))
		{
			case 'SALE':
				$paydrv->transactionSale($obj_req);
				$res = TransactionTrnModel::TRN_SALE;
				break;
			case 'AUTH':
				$paydrv->transactionAuthorization($obj_req);
				$res = TransactionTrnModel::TRN_AUTHORIZATION;
				break;
			default:
				throw new InvalidArgumentException();
		}
		//
		return $res;
	}
	/**
	 * 
	 */
	protected function _getHttpRequestParserModelName()
	{
		return 'SaleTransactionModel';
	}
}

/* End of file */