<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');
require_once(APPPATH.'classes/ci_extend_libraries/PaymentControllerBase.abstract.php');	

/**
 * 
 */
class Void extends PaymentControllerBase 
{
	/**
	 * コンストラクタ
	 */
	public function __construct()
	{
		parent::__construct();	
	}
	/**
	 * index
	 */
	public function index()
	{
		$this->_execTransaction();
	}
	/**
	 * 
	 */
	protected function _onSubmit(&$paydrv, &$obj_req)
	{
		// void 可能か確認
		$dovoid = $paydrv->isAvailableVoid($obj_req, $obj_req->TRN_ID);
		$docredit = !$dovoid;
		// void 実行
		if($dovoid)
		{
			$res = TransactionTrnModel::TRN_VOID;
			$paydrv->transactionVoid($obj_req, $obj_req->TRN_ID);
			$docredit = !$paydrv->isTransactionSucceed();	// 失敗したら credit も実行
		}
		// credit 実行
		if($docredit)
		{
			$res = TransactionTrnModel::TRN_CREDIT;
			$paydrv->transactionCredit($obj_req, $obj_req->TRN_ID);
		}
		// 復帰
		return $res;
	}
	/**
	 * 
	 */
	protected function _getHttpRequestParserModelName()
	{
		return 'TransidTransactionModel';
	}
}

/* End of file */