<?php  if (!defined('BASEPATH')) exit('No direct script access allowed');
require_once(BASEPATH.'libraries/Model.php');
/**
 * Payment
 */
class Payment extends Model 
{
	/**
	 * 
	 */
	protected $_merchant_info = null;
//	/**
//	 * 
//	 */
//	protected $_payment_info = null;

	/**
	 * コンストラクタ
	 */
    public function __construct()
    {
        parent::__construct();
    }
    /**
     * 
     */
    public function loginMerchant($loginid, $passwd)
    {
    	// MerchantTbl 読み込み
		$MODEL =& self::_getTableModel('MerchantTblModel');
		$res_mer = $MODEL->getAccount($loginid, $passwd);
		if(empty($res_mer))
			return false;
		$this->_merchant_info = $res_mer;
    	// PaymentGwMst 読み込み
		$MODEL =& self::_getTableModel('PaymentGwMstModel');
		$res_pay = $MODEL->getPKey($res_mer->PAYMENT_GW_ID);
		if(empty($res_pay))
			return false;
		// ドライバー読み込み
    	if(!$this->_loadPaymentDriver($res_pay->NAME))
    		return false;
    	// ドライバー初期化
    	$DRIVER =& $this->getPaymentDriver();
//		$DRIVER->initialize($res_mer, $res_pay);
		$DRIVER->initialize($res_pay);
    	// 
    	return true;
    }
    /**
     * 
     */
    public function& getPaymentDriver()
    {
		$CI =& get_instance();
		return $CI->PaymentDriver;
    }
    /**
     * 
     */
    protected function _loadPaymentDriver($driver)
    {
		$CI =& get_instance();
		$path = "payment/drivers/${driver}/${driver}PaymentDriver";
		$CI->load->model($path, 'PaymentDriver', true);
		//
		return !empty($CI->PaymentDriver);
    }
    /**
     * 
     */
    protected static function& _getTableModel($name)
    {
		$CI =& get_instance();
		$CI->load->model('database/tables/' . $name, '', true);
		return $CI->$name;
    }
    /**
     * 
     */
    public function getMerchantInfo($member = null)
    {
    	if(empty($member))
			return $this->_merchant_info;
		else
			return $this->_merchant_info->$member;
    }
}

/* End of file */