<?php  if (!defined('BASEPATH')) exit('No direct script access allowed');
require_once(APPPATH.'classes/ci_extend_libraries/DatabaseTableModelBase.abstract.php');
	
/**
 * TransactionTrnModel クラス
 */
class TransactionTrnModel extends DatabaseTableModelBase 
{
	/**
	 * 
	 */
	const TRN_UNKNOWN			= 0;
	const TRN_SALE				= 1;
	const TRN_AUTHORIZATION		= 2;
	const TRN_DELAYEDCAPTURE	= 3;
	const TRN_CREDIT			= 4;
	const TRN_VOID   			= 5;
	
	/**
	 * テーブル名
	 * @abstract
	 */
	protected $_tablename = 'transaction_trn';

	/**
	 * コンストラクタ
	 */
    public function __construct()
    {
        parent::__construct();
    }

	/**
	 * 
	 */
	public function writeValue($trnid, $orgtrnid, $processed, $merchantid)
	{
		$datas['TRN_ID']		= $trnid;
		$datas['ORIG_TRN_ID']	= $orgtrnid;
		$datas['MERCHANT_ID']	= $merchantid;
		$datas['PROCESSED']		= $processed;
		$datas['UPDATE_DTM']	= date('Y-m-d H:i:s.u');
		$keys = array('TRN_ID'/*, 'ORIG_TRN_ID'*/);
		// UPDATE
		return $this->replaceArray($datas, $keys);
	}
//	/**
//	 * 
//	 */
//	public function updateProcessed($trnid, $processed)
//	{
//		$datas['TRN_ID']		= $trnid;
//		$datas['PROCESSED']		= $processed;
//		$datas['UPDATE_DTM']	= date('Y-m-d H:i:s.u');
//		$keys = array('TRN_ID');
//		// UPDATE
//		return $this->updateArray($datas, $keys);
//	}
	/**
	 * 
	 */
	public function getValue($trnid)
	{
		$keys = array(
			'TRN_ID' => $trnid,
		);
		// SELECT
		return $this->getRow($keys);
	}
}

/* End of file */